
unit libdevmem;
interface

uses
  ctypes;

{
  Automatically converted by H2Pas 1.0.0 from libdevmem.h
  The following command line parameters were used:
    -D
    -c
    -C
    -T
    -l
    libdevmem
    libdevmem.h
    -o
    libdevmem.pas
}

    const
      External_library='libdevmem'; {Setup as you need}

{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}


{ libdevmem. Copyright 2003 Arcom Ltd  }
{$ifndef __LIBDEVMEM_H__}
{$define __LIBDEVMEM_H__}
{$include <stdint.h>}
{ C++ extern C conditionnal removed }
{ 
 * A handle for an open mapping. This structure is opaque and should
 * not be accessed directly
  }
type

   Tlibdevmem_handle_t = record
        base : ^Tuint8_t;
        mapping : pointer;
        length : Tculong;
        fd : Tcint;
     end;
   Tlibdevmem_handle = ^Tlibdevmem_handle_t;
{ libdevmem_open - Open a mapping to a physical address location. 
 *
 * base		The physical address to map
 * length	The length of the region to map
 *
 * returns	A handle to the mapping. On error NULL is returned and errno is set.
  }

function libdevmem_open(base:Tculong; length:Tculong):Tlibdevmem_handle;cdecl;external External_library name 'libdevmem_open';
{ libdevmem_close - Close a mapping.
 *
 * handle	The mapping to close
 *
 * returns	0 on success. On error -1 is returned and errno is set.
  }
function libdevmem_close(handle:Tlibdevmem_handle):Tcint;cdecl;external External_library name 'libdevmem_close';
{ libdevmem_read_uint8 - Read an unsigned 8 bit value from an offset into a mapping 
 *
 * handle	The mapping to access
 * offset	Offset into the mapping to read from
 *
 * returns	An unsigned 8 bit value
  }
(* error 
static inline uint8_t libdevmem_read_uint8(libdevmem_handle handle, unsigned long offset)
(* error 
static inline uint8_t libdevmem_read_uint8(libdevmem_handle handle, unsigned long offset)
 in declarator_list *)
 in declarator_list *)
(* error 
	volatile uint8_t *reg = (volatile uint8_t *)(handle->base + offset);
 in declarator_list *)
  var
     reg : ^Treturn;cvar;public;
(* error 
}
{ libdevmem_write_uint8 - Write an unsigned 8 bit value to an offset in a mapping 
 *
 * handle	The mapping to access
 * offset	Offset into the mapping to write to
 * value	The unsigned 8 bit value to write
 *
 * returns	n/a
  }
in declaration at line 62 *)
(* error 
	*reg = value;
in declaration at line 63 *)
(* error 
}
    { libdevmem_read_uint16 - Read an unsigned 16 bit value from an offset into a mapping 
     *
     * handle	The mapping to access
     * offset	Offset into the mapping to read from
     *
     * returns	An unsigned 16 bit value
      }
in declaration at line 75 *)
         reg : ^Treturn;cvar;public;
(* error 
}
    { libdevmem_write_uint16 - Write an unsigned 16 bit value to an offset in a mapping 
     *
     * handle	The mapping to access
     * offset	Offset into the mapping to write to
     * value	The unsigned 16 bit value to write
     *
     * returns	n/a
      }
in declaration at line 89 *)
(* error 
	*reg = value;
in declaration at line 90 *)
(* error 
}
    { libdevmem_read_uint32 - Read an unsigned 32 bit value from an offset into a mapping 
     *
     * handle	The mapping to access
     * offset	Offset into the mapping to read from
     *
     * returns	An unsigned 32 bit value
      }
in declaration at line 102 *)
         reg : ^Treturn;cvar;public;
(* error 
}
    { libdevmem_write_uint32 - Write an unsigned 32 bit value to an offset in a mapping 
     *
     * handle	The mapping to access
     * offset	Offset into the mapping to write to
     * value	The unsigned 32 bit value to write
     *
     * returns	n/a
      }
in declaration at line 116 *)
(* error 
	*reg = value;
in declaration at line 117 *)
(* error 
}
{ C++ end of extern C conditionnal removed }
{$endif}
    { __LIBDEVMEM_H__  }

implementation


end.
